# Galaxy
Galaxy simulation implemented by Haskell.

## Reference
- https://stackoverflow.com/questions/30740366/list-with-random-numbers-in-haskell
- http://www.cs.columbia.edu/~sedwards/classes/2020/4995-fall/reports/NBody.pdf
- http://www.cs.columbia.edu/~sedwards/classes/2021/4995-fall/index.html
- https://hackage.haskell.org/package/gloss-1.13.2.1/docs/Graphics-Gloss-Interface-Pure-Simulate.html

## Prerequisites
Install random package.
```
stack ghci --package random
```
Install parallel package.
```
stack install parallel
```
Install gloss package.
```
stack install gloss
```
Package for threadscope.
```
sudo apt install libcanberra-gtk-module
```

## Compile
```
stack ghc -- -O2 -threaded -rtsopts -eventlog Galaxy.hs -Wall
```

## Run
```
time ./Galaxy <planets number> <steps> <time interval> +RTS -N1 -ls
```
For example
```
./Galaxy 50 100 1 +RTS -N1 -s
```
For example
```
./Galaxy 1 1 1 +RTS -N1 -s
```
For example
```
./Galaxy 2000 10 1 depth +RTS -N8 -s
```

## Check threadscope
```
threadscope Galaxy.eventlog
```

./Galaxy 100 100 10 +RTS -N1 -ls && threadscope Galaxy.eventlog
./Galaxy 100000 10 0.1 +RTS -N4 -ls && threadscope Galaxy.eventlog


