{-
  This file
-}

module Visualize (
  runSimulation,
  windowSize
) where

import GHC.Float
import Graphics.Gloss
import Control.Parallel.Strategies
import qualified Planet as P
import qualified Laws as L

windowSize :: Int
windowSize = 720

drawPlanet :: P.Planet -> Picture
drawPlanet p = Color white $ Translate x y (circleSolid (realToFrac $ 0.5 * log (P.mass p)))
  where x = realToFrac $ P.posX p
        y = realToFrac $ P.posY p

drawPlanets :: [P.Planet] -> [Picture]
drawPlanets ps = map drawPlanet ps

runSimulation :: [P.Planet] -> IO ()
runSimulation ps =  simulate (InWindow "Galaxy Simulation" (windowSize, windowSize) (100, 100))
                    black 60
                    ps
                    (\ps' -> pictures $ drawPlanets ps')
                    (\_ dt ps' -> L.nextState ps' (float2Double dt))
